///////////////////////////////////////////////////////////////////////////////
// Title      : DIOT WIC testbench top file
// Project    : Distributed I/O Tier
///////////////////////////////////////////////////////////////////////////////
// File       : tb_top.vhd
// Author     : Denia Bouhired <denia.bouhired@cern.ch>
// Company    : CERN (BE-CO-HT)
// Standard   : VHDL
///////////////////////////////////////////////////////////////////////////////
// Description:
// DIOT/WIC testbench top file
//
///////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2018 CERN
//
// Copyright and related rights are licensed under the Solderpad Hardware
// License, Version 0.51 (the “License”) (which enables you, at your option,
// to treat this file as licensed under the Apache License 2.0); you may not
// use this file except in compliance with the License. You may obtain a copy
// of the License at http://solderpad.org/licenses/SHL-0.51.
// Unless required by applicable law or agreed to in writing, software,
// hardware and materials distributed under this License is distributed on an
// “AS IS” BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
// or implied. See the License for the specific language governing permissions
// and limitations under the License.
//
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/1ps
`include "fip_frame.svh"

module tb_top;
  import DIOT_pkg :: *;

  dut_harness harness();

  initial begin

    automatic uint8_t payload[0:123] = '{124{'h00}};
    tb_env env;
    $display("Testbench starting...");
    #10us;      // wait for reset
    env = new (4, harness.DUT_nf_if, harness.DUT_fd_if);
    for (int j=0; j<5; j++) begin
        $display("=====================");
        $display("Cycle ", j);
        env.run(5);
        $display ("Next payload is %p", env.gen.DIO_payload[0:31] );
        #5ms;      // silence time
        #500us;      // silence time
     end

  $stop();

  end

endmodule : tb_top
